using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace Regressionsgerade01
{
	public class Form1 : System.Windows.Forms.Form
	{
		/// <summary>
		/// Erforderliche Designervariable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		public Form1()
		{
			InitializeComponent();
		}
		/// <summary>
		/// Die verwendeten Ressourcen bereinigen.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Vom Windows Form-Designer generierter Code
		/// <summary>
		/// Erforderliche Methode fr die Designeruntersttzung. 
		/// Der Inhalt der Methode darf nicht mit dem Code-Editor gendert werden.
		/// </summary>
		private void InitializeComponent()
		{
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(592, 566);
			this.Name = "Form1";
			this.Text = "Regressionsgerade01";
			this.Resize += new System.EventHandler(this.Form1_Resize);
			this.Load += new System.EventHandler(this.Form1_Load);
			this.Paint += new System.Windows.Forms.PaintEventHandler(this.Form1_Paint);

		}
		#endregion

		/// <summary>
		/// Der Haupteinstiegspunkt fr die Anwendung.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}
		private void Form1_Load(object sender, System.EventArgs e)
		{

		}

		private void Form1_Paint(object sender, System.Windows.Forms.PaintEventArgs e)
		{
			Graphics grfx=e.Graphics;
			int nFensterBreite=ClientSize.Width-1;
			int nFensterHhe=ClientSize.Height-1;
			Font arial12=new Font("Arial",12);
			grfx.DrawString("Die Regressionsgerade ist grn.",arial12,Brushes.Green,nFensterBreite/4,10);
			grfx.DrawString("Die Messwerte sind schwarz mit roten Kreuzen gezeichnet.",arial12,Brushes.Black,nFensterBreite/4,30);
			PointF[] fPunkte = new PointF[]	// Messwerte
			{
			new PointF( 30f,340f), new PointF( 50f,421f), new PointF( 70f,496f),
			new PointF( 90f,563f), new PointF(110f,623f), new PointF(130f,677f),
			new PointF(150f,726f), new PointF(170f,772f), new PointF(190f,817f),
			new PointF(210f,860f), new PointF(230f,903f)};
			int nAnz= fPunkte.Length;	// Anzahl der Messwerte
			// Berechnung der Steigung und des absoluten Wertes
			// zuerst berechne die Summe und die Mittelwerte
			float fSumX=0.0f,fSumY=0f,fXmit,fYmit;
			for(int i=0;i<nAnz;i++){ fSumX +=fPunkte[i].X; fSumY +=fPunkte[i].Y;};
			fXmit=fSumX/nAnz; fYmit=fSumY/nAnz;
			// Berechne die Summe der Quadrate
			float fSumXX=0.0f,fSumXY=0.0f;
			for(int i=0;i<nAnz;i++){fSumXX +=fPunkte[i].X*fPunkte[i].X;fSumXY +=fPunkte[i].X*fPunkte[i].Y;}
			// Berechne die Steigung fM und den absoluten Wert fQ
			float fQ, fM;
			fM=(fSumXY-nAnz*fXmit*fYmit)/(fSumXX-nAnz*fXmit*fXmit);
   fQ=fYmit- fM*fXmit;
			float fX=nFensterBreite/(250.0f-0f);// X Skalierungsfaktor Max-Min
			float fY=nFensterHhe/(1000.0f-300.0f);// Y Skalierungsfaktor Max-Min
			for(int i=0;i<nAnz;i++)
			{
				fPunkte[i].X *=fX;
				fPunkte[i].Y=nFensterHhe+250 -fPunkte[i].Y*fY; // bei 340 untere Linie
			}
			for(int i=0;i<nAnz;i++)// Zeichne ein rotes + Zeichen an den Messpunkten
			{ 
				Pen penr=new Pen(Color.Red);
				grfx.DrawLine(penr,fPunkte[i].X-5,fPunkte[i].Y,fPunkte[i].X+5, fPunkte[i].Y);
				grfx.DrawLine(penr,fPunkte[i].X,fPunkte[i].Y-5,fPunkte[i].X, fPunkte[i].Y+5);
			}
			Pen pens = new Pen(Color.Black);
			grfx.DrawLines(pens, fPunkte);// Zeichne Linie von Messpunkt zu Messpunkt
			// Bei verndern der Fenstergre merken Sie dass die Normierung auf den
			// unteren Wert verbesserungswrdig ist? Bitte verbessern !
			// man darf nicht 300 schreiben, sondern z.B. nFensterhhe/2 usw.
			// Hier wird die Steigung und der absolute Wert eingesetzt
			PointF[] fRegGerade=// new PointF[2]	kann fehlen funktioniert auch
			{
			new PointF(20f*fX,nFensterHhe+250f-(fM*20f+fQ)*fY),
			new PointF(235f*fX,nFensterHhe+250f-(fM*235f+fQ)*fY)
			};
			Pen pengr = new Pen(Color.Green);
			grfx.DrawLines(pengr,fRegGerade);	// Zeichne Gerade zwischen zwei Punkten
		}
		private void Form1_Resize(object sender, System.EventArgs e)
		{
			ResizeRedraw=true;
		}
	}
}
